<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve all concept of Graph</p>
		<button onclick="graph()">Graph concept</button>
		<p id="demo"></p>

		<script>
			function graph() {
			
				// Queue class 
				class Queue 
				{ 
					// Array is used to implement a Queue 
					constructor() 
					{ 
						this.items = []; 
					} 
								  
					// enqueue function 
					enqueue(element) 
					{     
						// adding element to the queue 
						this.items.push(element); 
					}
					
					// dequeue function 
					dequeue() 
					{ 
						// removing element from the queue returns underflow when called  on empty queue 
						if(this.isEmpty()) 
							return "Underflow"; 
						return this.items.shift(); 
					} 
					
					
					// front function 
					front() 
					{ 
						// returns the Front element of  
						// the queue without removing it. 
						if(this.isEmpty()) 
							return "No elements in Queue"; 
						return this.items[0]; 
					} 


					// isEmpty function 
					isEmpty() 
					{ 
						// return true if the queue is empty. 
						return this.items.length == 0; 
					}
					
					
					// printQueue function 
					printQueue() 
					{ 
						var str = ""; 
						for(var i = 0; i < this.items.length; i++) 
							str += this.items[i] +" "; 
						return str; 
					} 
				}
				class Graph {
				// defining vertex array and adjacent list
				constructor(noOfVertices) {
					this.noOfVertices = noOfVertices;
					this.AdjList = new Map();
				}
				
				//function to add the vertex
				addVertex(v) {
					// initialize the adjacent list with a null array
					this.AdjList.set(v, []);
				}
				
				// addEdge(v, w)
				addEdge(v, w) {
					// get the list for vertex v and put the vertex w denoting edge betweeen v and w
					this.AdjList.get(v).push(w);
					// Since graph is undirected, add an edge from w to v also
					this.AdjList.get(w).push(v);
				}
				
				// printGraph()
				printGraph() {
					// get all the vertices
					var get_keys = this.AdjList.keys();
					// iterate over the vertices
					for (var i of get_keys)
					{
						// great the corresponding adjacency list for the vertex
						var get_values = this.AdjList.get(i);
						var conc = "";
						// iterate over the adjacency list concatenate the values into a string
						for (var j of get_values)
							conc += j + " ";
						// print the vertex and its adjacency list
						console.log(i + " -> " + conc);
					}
				}

				// function to performs BFS
				bfs(startingNode) {
				// create a visited array
				var visited = [];
				for (var i = 0; i < this.noOfVertices; i++)
					visited[i] = false;
				// Create an object for queue
				var q = new Queue();
				
				// add the starting node to the queue
				visited[startingNode] = true;
				q.enqueue(startingNode);
				// loop until queue is element
				while (!q.isEmpty()) {
					// get the element from the queue
					var getQueueElement = q.dequeue();
					// passing the current vertex to callback funtion
					console.log(getQueueElement);
					// get the adjacent list for current vertex
					var get_List = this.AdjList.get(getQueueElement);
					// loop through the list and add the elemnet to the queue if it is not processed yet
					for (var i in get_List) {
						var neigh = get_List[i];
						if (!visited[neigh]) {
							visited[neigh] = true;
							q.enqueue(neigh);
							}
						}
					}	
				}
			}
			
			// Using the above implemented graph class
			var g = new Graph(6);
			var vertices = [ 'A', 'B', 'C', 'D', 'E', 'F' ];
			
			// adding vertices
			for (var i = 0; i < vertices.length; i++) {
				g.addVertex(vertices[i]);
			}
			
			// adding edges
			g.addEdge('A', 'B');
			g.addEdge('A', 'D');
			g.addEdge('A', 'E');
			g.addEdge('B', 'C');
			g.addEdge('D', 'E');
			g.addEdge('E', 'F');
			g.addEdge('E', 'C');
			g.addEdge('C', 'F');
			
			// prints all vertex and its adjacency list
			// A -> B D E
			// B -> A C
			// C -> B E F
			// D -> A E
			// E -> A D F C
			// F -> E C
			g.printGraph();
			
			// prints BFS      A B D E C F
			console.log("BFS");
			g.bfs('A');
			
		}
		</script>

	</body>
</html>